"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Common_1 = require("../Utils/Common");
const Reducer_1 = require("./Reducer");
const Permissions_1 = require("../Permissions/Permissions");
class Factory extends Permissions_1.Permissions {
    constructor(framework) {
        super(framework);
        this.framework = framework;
        this.createEventStore = async (factory, fromAddress) => {
            let tx = await factory.createEventStore({
                from: fromAddress,
                gas: 4000000
            });
            let fsa = Common_1.getFSAFromEventArgs(tx.logs[0].args);
            return {
                events: [fsa],
                tx: tx
            };
        };
        this.getAllEventStoreContractAddresses = async (factory, fromAddress) => {
            let addresses = await factory.getEventStores({
                from: fromAddress
            });
            return addresses;
        };
        this.getFactoryReadModel = async (factory, fromAddress) => {
            return this.framework.ReadModel.getCachedReadModel(factory, fromAddress, Reducer_1.readModel, Reducer_1.reducer);
        };
    }
}
exports.Factory = Factory;
//# sourceMappingURL=Factory.js.map