"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = require("lodash"), keys = _a.keys, pick = _a.pick, omit = _a.omit, flatten = _a.flatten, difference = _a.difference, extend = _a.extend;
var DEBUG = true; //should be only for dev envs for performance reasons...
var Common_1 = require("./Utils/Common");
var Common = require("./Utils/Common");
var EventStore = /** @class */ (function () {
    function EventStore(framework) {
        var _this = this;
        this.framework = framework;
        // Add modules here for convenience
        this.Common = Common;
        this.writeUnmarshalledEsCommand = function (eventStore, fromAddress, esEvent) { return __awaiter(_this, void 0, void 0, function () {
            var marshalledEvent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        marshalledEvent = Common_1.marshal(esEvent.eventType, esEvent.keyType, esEvent.valueType, esEvent.key, esEvent.value);
                        return [4 /*yield*/, eventStore.writeEvent(marshalledEvent.eventType, marshalledEvent.keyType, marshalledEvent.valueType, marshalledEvent.key, marshalledEvent.value, { from: fromAddress, gas: 4000000 })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.readFSA = function (eventStore, fromAddress, eventId) { return __awaiter(_this, void 0, void 0, function () {
            var esEventValues, fsa, path, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.readEsEventValues(eventStore, fromAddress, eventId)];
                    case 1:
                        esEventValues = _b.sent();
                        fsa = Common_1.getFSAFromEventValues(esEventValues[0], // uint    - eventId
                        esEventValues[1], // address - tx origin
                        esEventValues[2], // uint    - created
                        esEventValues[3], // bytes32 - event type
                        esEventValues[4], // bytes1  - key type
                        esEventValues[5], // bytes1  - value type
                        esEventValues[6], // bytes32 - key
                        esEventValues[7] // bytes32 - value
                        );
                        if (!(fsa.meta.valueType === "I")) return [3 /*break*/, 3];
                        if (!this.framework.TransmuteIpfs.ipfs) {
                            // force local ipfs, protect infura from spam
                            this.framework.TransmuteIpfs.init({
                                host: "localhost",
                                port: "5001",
                                options: {
                                    protocol: "http"
                                }
                            });
                        }
                        path = fsa.payload.multihash;
                        // readBuffer(hash)  readObject(path)
                        // Check if object is on IPFS
                        //const objectIsOnIPFS = ;
                        //if (!objectIsOnIPFS) throw('Object is not on IPFS!');
                        _a = fsa;
                        return [4 /*yield*/, this.framework.TransmuteIpfs.readObject(path)];
                    case 2:
                        // readBuffer(hash)  readObject(path)
                        // Check if object is on IPFS
                        //const objectIsOnIPFS = ;
                        //if (!objectIsOnIPFS) throw('Object is not on IPFS!');
                        _a.payload = _b.sent();
                        // remove circular refernce from IPLD
                        fsa.payload = JSON.parse(JSON.stringify(fsa.payload));
                        fsa.meta.multihash = path;
                        _b.label = 3;
                    case 3: return [2 /*return*/, fsa];
                }
            });
        }); };
        this.readEsEventValues = function (eventStore, fromAddress, eventId) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, eventStore.readEvent.call(eventId, {
                            from: fromAddress
                        })];
                    case 1: 
                    // @Orie, should this be a constant since it is a call fn? Also, don't need gas, etc.
                    return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        // probably should return TX here tooo
        this.writeFSA = function (eventStore, fromAddress, fsa) { return __awaiter(_this, void 0, void 0, function () {
            var payloadKeys, valueType, keyType, key, value, hash, isHex, formatHex, unmarshalledEsCommand, tx, event;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (fsa.payload.length) {
                            throw "fsa payload cannot be an array";
                        }
                        payloadKeys = Object.keys(fsa.payload);
                        if (!(payloadKeys.length > 1)) return [3 /*break*/, 2];
                        // CONVERT TO IPLD
                        valueType = "I";
                        return [4 /*yield*/, this.framework.TransmuteIpfs.writeObject(fsa.payload)];
                    case 1:
                        hash = _a.sent();
                        //console.log("Ipfs hash: " + hash)
                        key = "multihash";
                        value = hash;
                        return [3 /*break*/, 3];
                    case 2:
                        valueType = Common.guessTypeFromValue(fsa.payload[payloadKeys[0]]);
                        // console.log('valueType: ', valueType)
                        key = payloadKeys[0];
                        value = fsa.payload[payloadKeys[0]];
                        _a.label = 3;
                    case 3:
                        isHex = function (h) {
                            return h.replace(/^0x/i, "").match(/[0-9A-Fa-f]+$/)
                                ? h.replace(/^0x/i, "").match(/[0-9A-Fa-f]+$/)["index"] == 0
                                : false;
                        };
                        formatHex = function (h) { return "0x" + h.replace(/^0x/i, ""); };
                        // console.log(valueType);
                        // console.log(value);
                        // console.log(keyType);
                        // console.log(key);
                        if (key == "bytes32") {
                            // 32-Byte hex - '0x32fa'
                            if (valueType == "X") {
                                if (value.length > 66)
                                    // check length
                                    throw "solidity bytes32 type exceeded 32 bytes: " +
                                        value.length +
                                        " nybbles";
                                if (!isHex(value))
                                    // check hex chars only 0-f/F
                                    throw "solidity bytes32 received invalid hex string: " + value;
                                // 32-Byte hex - 'the dog jumped'
                            }
                            else if (valueType == "S") {
                                if (value.length > 32)
                                    // check length of string
                                    throw "solidity bytes32 type exceeded 32 bytes: " +
                                        value.length +
                                        " chars";
                            }
                            else
                                throw "Invalid value type - " + valueType;
                        }
                        else if (key == "address") {
                            // address - 20 bytes
                            if (valueType == "A") {
                                if (!isHex(value))
                                    // check hex chars only 0-f/F
                                    throw "solidity address received invalid hex string: " + value;
                                if (formatHex(value).length != 42)
                                    throw "solidity address received invalid length: " + value;
                            }
                            else
                                throw "Invalid value type - " + valueType;
                        }
                        unmarshalledEsCommand = {
                            eventType: fsa.type,
                            keyType: "X",
                            valueType: valueType,
                            key: key,
                            value: value
                        };
                        return [4 /*yield*/, this.writeUnmarshalledEsCommand(eventStore, fromAddress, unmarshalledEsCommand)];
                    case 4:
                        tx = _a.sent();
                        event = tx.logs[0].args;
                        return [2 /*return*/, Common.getFSAFromEventArgs(event)];
                }
            });
        }); };
        /**
          * @param {TruffleContract} eventStore - a contract instance which is an Event Store
          * @param {Number} eventId - all events after this Id and includig it will be returned
          * @return {Promise<EsEvent[], Error>} json objects representing SOLIDITY_EVENTs
          */
        this.readFSAs = function (eventStore, fromAddress, eventId) {
            if (eventId === void 0) { eventId = 0; }
            return __awaiter(_this, void 0, void 0, function () {
                var currentEvent, eventPromises, fsa;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, eventStore.eventCount.call({
                                from: fromAddress
                            })];
                        case 1:
                            currentEvent = (_a.sent()).toNumber();
                            eventPromises = [];
                            _a.label = 2;
                        case 2:
                            if (!(eventId < currentEvent)) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.readFSA(eventStore, fromAddress, eventId)];
                        case 3:
                            fsa = _a.sent();
                            eventPromises.push(fsa);
                            eventId++;
                            return [3 /*break*/, 2];
                        case 4: return [4 /*yield*/, Promise.all(eventPromises)];
                        case 5: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
           * @param {TruffleContract} eventStore - a contract instance which is an Event Store
           * @param {Address} fromAddress - the address you wish to deploy these events from
           * @param {Array<ITransmuteCommand>} transmuteCommands - an array of FSA objects to be written to the chain
           * @return {Array<EventTypes.ITransmuteCommandResponse>} - an array of transmute command responses
           */
        this.writeFSAs = function (eventStore, fromAddress, transmuteCommands) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var promises;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        promises = transmuteCommands.map(function (cmd) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.writeFSA(eventStore, fromAddress, cmd)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(promises)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
    }
    return EventStore;
}());
exports.EventStore = EventStore;
//# sourceMappingURL=EventStore.js.map