"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FallbackLocalStorage = require('fallback-local-storage');
var appStorage;
if (FallbackLocalStorage.getStorage().includes('localStorage')) {
    appStorage = localStorage;
}
else {
    appStorage = new FallbackLocalStorage();
}
var LocalStore;
(function (LocalStore) {
    // Auto detect supported storage adapter (default behavior)
    var store = appStorage;
    /**
     * @param {String} key - a key for a stored object
     * @return {Object} a promise for the object at the given key
     */
    LocalStore.getItem = function (key) {
        return new Promise(function (resolve, reject) {
            var itemAsString = store.getItem(key);
            try {
                resolve(JSON.parse(itemAsString));
            }
            catch (e) {
                resolve(itemAsString);
            }
        });
    };
    /**
     * @param {String} key - a key for a stored object
     * @param {Object} value - the object to be stored
     * @return {Object} a promise for the object at the given key
     */
    LocalStore.setItem = function (key, value) {
        return new Promise(function (resolve, reject) {
            store.setItem(key, JSON.stringify(value));
            resolve(value);
        });
    };
})(LocalStore = exports.LocalStore || (exports.LocalStore = {}));
//# sourceMappingURL=LocalStore.js.map