"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var Web3 = require("web3");
var ProviderEngine = require("web3-provider-engine");
var FetchSubprovider = require("web3-provider-engine/subproviders/fetch.js");
var WalletSubprovider = require("web3-provider-engine/subproviders/wallet.js");
var HookedWalletProvider = require("web3-provider-engine/subproviders/hooked-wallet.js");
var Web3Subprovider = require("web3-provider-engine/subproviders/web3.js");
var Transaction = require("ethereumjs-tx");
var util = require("ethereumjs-util");
var bip39 = require("bip39");
var hdkey = require("ethereumjs-wallet/hdkey");
var com = require("./Common");
exports.getWalletProvider = function (rpcUrl) { return __awaiter(_this, void 0, void 0, function () {
    var engine, web3, mnemonic, hdwallet, walletHDPath, wallet, address;
    return __generator(this, function (_a) {
        engine = new ProviderEngine();
        web3 = new Web3(engine);
        mnemonic = bip39.generateMnemonic();
        hdwallet = hdkey.fromMasterSeed(bip39.mnemonicToSeed(mnemonic));
        walletHDPath = "m/44'/60'/0'/0/";
        wallet = hdwallet.derivePath(walletHDPath + "0").getWallet();
        address = "0x" + wallet.getAddress().toString("hex");
        engine.addProvider(new WalletSubprovider(wallet, {}));
        engine.addProvider(new FetchSubprovider({
            rpcUrl: rpcUrl
        }));
        engine.start();
        return [2 /*return*/, {
                address: address,
                engine: engine,
                web3: web3
            }];
    });
}); };
exports.getWeb3Provider = function (rpcUrl) { return __awaiter(_this, void 0, void 0, function () {
    var engine, web3, address;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                engine = new ProviderEngine();
                web3 = new Web3(new Web3.providers.HttpProvider(rpcUrl));
                return [4 /*yield*/, com.getAddress(web3)];
            case 1:
                address = _a.sent();
                return [2 /*return*/, {
                        address: address,
                        engine: engine,
                        web3: web3
                    }];
        }
    });
}); };
exports.getFetchProvider = function (rpcUrl) { return __awaiter(_this, void 0, void 0, function () {
    var engine, web3, address;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                engine = new ProviderEngine();
                web3 = new Web3(engine);
                engine.addProvider(new FetchSubprovider({
                    rpcUrl: rpcUrl
                }));
                engine.start();
                return [4 /*yield*/, com.getAddress(web3)];
            case 1:
                address = _a.sent();
                return [2 /*return*/, {
                        address: address,
                        engine: engine,
                        web3: web3
                    }];
        }
    });
}); };
exports.getHookedWalletProvider = function (rpcUrl) { return __awaiter(_this, void 0, void 0, function () {
    function concatSig(v, r, s) {
        r = util.fromSigned(r);
        s = util.fromSigned(s);
        v = util.bufferToInt(v);
        r = util.toUnsigned(r).toString("hex");
        s = util.toUnsigned(s).toString("hex");
        v = util.stripHexPrefix(util.intToHex(v));
        var value = r.concat(s, v).toString("hex");
        return util.addHexPrefix(value);
    }
    var engine, web3, privateKey, address, addressHex;
    return __generator(this, function (_a) {
        engine = new ProviderEngine();
        web3 = new Web3(engine);
        privateKey = new Buffer("cccd8f4d88de61f92f3747e4a9604a0395e6ad5138add4bec4a2ddf231ee24f9", "hex");
        address = new Buffer("1234362ef32bcd26d3dd18ca749378213625ba0b", "hex");
        addressHex = "0x" + address.toString("hex");
        engine.addProvider(new HookedWalletProvider({
            getAccounts: function (cb) {
                cb(null, [addressHex]);
            },
            signTransaction: function (txParams, cb) {
                var tx = new Transaction(txParams);
                tx.sign(privateKey);
                var rawTx = "0x" + tx.serialize().toString("hex");
                cb(null, rawTx);
            },
            signMessage: function (msgParams, cb) {
                var msgHash = util.sha3(msgParams.data);
                var sig = util.ecsign(msgHash, privateKey);
                var serialized = util.bufferToHex(concatSig(sig.v, sig.r, sig.s));
                cb(null, serialized);
            }
        }));
        engine.addProvider(new FetchSubprovider({
            rpcUrl: rpcUrl
        }));
        engine.start();
        return [2 /*return*/, {
                address: addressHex,
                engine: engine,
                web3: web3
            }];
    });
}); };
//# sourceMappingURL=Web3Providers.js.map